/*-
 * Copyright 2011 Jason Harmening <jason.harmening@gmail.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef __TUV1236D_H__
#define __TUV1236D_H__

#include "pll_driver.h"

class tuv1236d
   : public pll_driver
{

   public:

      tuv1236d(tuner_config &config, tuner_device &device);

      virtual ~tuv1236d(void);

      virtual int set_channel(const dvb_channel &channel, dvb_interface &interface);
      
      virtual int set_channel(const avb_channel &channel);

      virtual int start(uint32_t timeout_ms);

      enum tuner_input
      {
         TUNER_INPUT_DEFAULT,
         TUNER_INPUT_1,
         TUNER_INPUT_2
      };

      void select_input(tuner_input input);

   protected:

      static const frequency_band tuv1236d_digital_bands[3];
      static const frequency_band tuv1236d_analog_bands[3];
      static const frequency_band tuv1236d_fm_bands[1];

      tuner_input m_input;
};

#endif
